; $Id: unpackcriscenterphas.pro,v 1.1 1998/01/26 17:55:01 rgr Exp $

; $RCSfile: unpackcriscenterphas.pro,v $
; $Author: rgr $
; $Date: 1998/01/26 17:55:01 $
; $Revision: 1.1 $

pro UnpackCrisCenterPhas, telemetry, index, telescope, event

   common CrisSymbols

   nevent = n_elements(index)
   MaxCenter = G$_Cris.CeNCtrPh
   
   center = bytarr((12*MaxCenter + 4)/8, nevent, /nozero)
   center(*,*) = 'ff'XB
   mask = intarr(MaxCenter, nevent, /nozero)
   mask(*,*) = 'ffff'X

   if (telescope eq 1) then begin
      set = where(event.R1 gt 0, ncount)
      if (ncount gt 0) then begin 
         nbyte = (12*(event(set).R1 + 1) + 4)/8
         nomask = event(set).R1
      endif
   endif else begin
      set = where(event.R2 gt 0, ncount)
      if (ncount gt 0) then begin
         nbyte = (12*(event(set).R2 + 1) + 4)/8
         nomask = event(set).R2
      endif
   endelse

   if (ncount gt 0) then begin
      for i=0, ncount-1 do begin
         ibyte1 = index(set(i))
         ibyte2 = ibyte1 + nbyte(i) - 1
         center(0 : nbyte(i)-1, set(i)) = telemetry(ibyte1 : ibyte2)
         mask(0 : nomask(i), set(i)) = 0
      endfor
      if (ncount eq 1) then nbyte = nbyte(0)
      index(set) = index(set) + nbyte
   endif

   center = reform(center, 3, MaxCenter/2, nevent, /overwrite)
   address = 2*indgen(MaxCenter/2)
   if (telescope eq 1) then begin
      event(0 : nevent-1).prim_ctr_ph(address) = mask(address,*) or   $
            reform(ishft(fix(center(0,*,*)), 4) or                    $
                   ishft(fix(center(1,*,*)), -4), MaxCenter/2, nevent)
      address = address + 1
      event(0 : nevent-1).prim_ctr_ph(address) = mask(address,*) or   $
                  reform(ishft(fix(center(1,*,*) and '0f'XB), 8) or   $
                              fix(center(2,*,*)), MaxCenter/2, nevent)
   endif else begin
      event(0 : nevent-1).sec_ctr_ph(address) = mask(address,*) or    $
            reform(ishft(fix(center(0,*,*)), 4) or                    $
                   ishft(fix(center(1,*,*)), -4), MaxCenter/2, nevent)
      address = address + 1
      event(0 : nevent-1).sec_ctr_ph(address) = mask(address,*) or    $
                  reform(ishft(fix(center(1,*,*) and '0f'XB), 8) or   $
                         fix(center(2,*,*)), MaxCenter/2, nevent)
   endelse

end
