; $Id: unpackcrisguardphas.pro,v 1.1 1998/01/26 17:55:03 rgr Exp $

; $RCSfile: unpackcrisguardphas.pro,v $
; $Author: rgr $
; $Date: 1998/01/26 17:55:03 $
; $Revision: 1.1 $

pro UnpackCrisGuardPhas, telemetry, index, telescope, event

   common CrisSymbols

   nevent = n_elements(index)
   MaxGuard = G$_Cris.CeNGuards
   
   guard = bytarr(2 * MaxGuard, nevent)
   
   if (telescope eq 1) then begin
      set = where((event.G1 gt 0) and (event.got_guard), ncount)
      if (ncount gt 0) then                                      $
         nbyte = 2 *event(set).G1
   endif else begin
      set = where((event.G2 gt 0) and (event.got_guard), ncount)
      if (ncount gt 0) then                                      $
         nbyte = 2 *event(set).G2
   endelse


   if (ncount gt 0) then begin
      for i=0, ncount-1 do begin
         ibyte1 = index(set(i))
         ibyte2 = ibyte1 + nbyte(i) - 1
         guard(0 : nbyte(i)-1, set(i)) = telemetry(ibyte1 : ibyte2)
      endfor
      if (ncount eq 1) then nbyte = nbyte(0)
      index(set) = index(set) + nbyte
   endif

   guard = reform(guard, 2, MaxGuard, nevent, /overwrite)
   guard = ishft(long(guard(0,*,*)), 8) or long(guard(1,*,*))
   guard = reform(guard, MaxGuard * nevent, /overwrite)
   address = fix(guard and '00000007'XL) - 2
   value = fix(ishft(guard, -4) and '00000fff'XL)

   pha = intarr(MaxGuard,  nevent, /nozero)
   pha(*,*) = 'ffff'X
   for i=0, MaxGuard-1 do begin
      set = where(address eq i, ncount)
      if (ncount gt 0) then pha(i, set/MaxGuard) = value(set)
   endfor


   if (telescope eq 1) then                                           $
      event(0 : nevent-1).prim_guard_ph = pha                         $
   else                                                               $
      event(0 : nevent-1).sec_guard_ph = pha

end      
