; $Id: unpacksismatrixstrips.pro,v 1.1 1998/01/26 17:57:08 rgr Exp $

; $RCSfile: unpacksismatrixstrips.pro,v $
; $Author: rgr $
; $Date: 1998/01/26 17:57:08 $
; $Revision: 1.1 $

pro UnpackSisMatrixStrips, telemetry, index, event

   common SisSymbols

   ; Put fill data in the matrix PHA arrays

   event.M1GndPha   = 'ffff'X
   event.M1FloatPha = 'ffff'X
   event.M2GndPha   = 'ffff'X
   event.M2FloatPha = 'ffff'X

   set = where(event.NumberMatrixStrips gt 0, ncount)
   nevent = ncount
   if (ncount gt 0) then begin
      if (ncount eq 1) then set = set(0)

      ; Build the strips from the telemetry bytes.

      MaxStrip = max(event(set).NumberMatrixStrips)
      MaxStrip = MaxStrip + (MaxStrip mod 2)
      mask = bytarr(MaxStrip, ncount, /nozero)
      mask(*,*) = 'ff'XB
      strips = bytarr((20*MaxStrip + 4)/8, ncount, /nozero)
      nstrip = event(set).NumberMatrixStrips
      nbyte = (20*nstrip + 4) / 8
      for i=0,ncount-1 do begin
         ibyte1 = index(set(i))
         ibyte2 = ibyte1 + nbyte(i) - 1
         strips(0 : nbyte(i)-1, i) = telemetry(ibyte1 : ibyte2)
         mask(0 : nstrip(i)-1, i) = 0B
      endfor
      strips = reform(strips, 5, MaxStrip/2, ncount, /overwrite)
      
      mask0 = mask(2*indgen(MaxStrip/2), *)
      mask1 = mask(2*indgen(MaxStrip/2) + 1, *)

      ; Update the event index.

      index(set) = index(set) + nbyte

      ; Break the strips into the plane, addr, and pha fields.

      plane = bytarr(MaxStrip, ncount, /nozero)
      plane(*,*) = 'ff'XB
      addr = bytarr(MaxStrip, ncount, /nozero)
      pha = intarr(MaxStrip, ncount, /nozero)
      address = 2 * indgen(MaxStrip/2)
      RawStrips = ishft(long(strips(0,*,*)), 12) or                   $
                  ishft(long(strips(1,*,*)),  4) or                   $
                  ishft(long(strips(2,*,*)), -4)
      plane(address, *) = mask0 or byte(ishft(RawStrips, -18))
      addr(address, *) = byte(ishft(RawStrips, -12)) and '3f'XB
      pha(address, *) = fix(RawStrips) and '0fff'X
      address = address + 1
      RawStrips = ishft(long(strips(2,*,*) and '0f'XB), 16) or        $
                  ishft(long(strips(3,*,*)),  8) or                   $
                  long(strips(4,*,*))
      plane(address, *) = mask1 or byte(ishft(RawStrips, -18))
      addr(address, *) = byte(ishft(RawStrips, -12)) and '3f'XB
      pha(address, *) = fix(RawStrips) and '0fff'X

      ; Store the PHA values for the strips in the appropriate arrays.

      nstrips = G$_Sis.NumMatrixStrips

      strip = where(plane eq 0B, ncount)
      if (ncount gt 0) then begin
         if (ncount eq 1) then strip = strip(0)
         address = addr(strip) + (strip/MaxStrip)*nstrips
         M1GndPha = intarr(nstrips, nevent, /nozero)
         M1GndPha(*,*) = 'ffff'X
         M1GndPha(address) = pha(strip)
         event(set).M1GndPha = M1GndPha
      endif
      strip = where(plane eq 1B, ncount)
      if (ncount gt 0) then begin
         if (ncount eq 1) then strip = strip(0)
         address = addr(strip) + (strip/MaxStrip)*nstrips
         M1FloatPha = intarr(nstrips, nevent, /nozero)
         M1FloatPha(*,*) = 'ffff'X
         M1FloatPha(address) = pha(strip)
         event(set).M1FloatPha = M1FloatPha
      endif
      strip = where(plane eq 2B, ncount)
      if (ncount gt 0) then begin
         if (ncount eq 1) then strip = strip(0)
         address = addr(strip) + (strip/MaxStrip)*nstrips
         M2GndPha = intarr(nstrips, nevent, /nozero)
         M2GndPha(*,*) = 'ffff'X
         M2GndPha(address) = pha(strip)
         event(set).M2GndPha = M2GndPha
      endif
      strip = where(plane eq 3B, ncount)
      if (ncount gt 0) then begin
         if (ncount eq 1) then strip = strip(0)
         address = addr(strip) + (strip/MaxStrip)*nstrips
         M2FloatPha = intarr(nstrips, nevent, /nozero)
         M2FloatPha(*,*) = 'ffff'X
         M2FloatPha(address) = pha(strip)
         event(set).M2FloatPha = M2FloatPha
      endif

   endif

end
