/* $Id: unpackEventHeader_s.c,v 1.2 1998/01/28 19:53:39 rgr Exp $ */

/* $RCSfile: unpackEventHeader_s.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/01/28 19:53:39 $ */
/* $Revision: 1.2 $ */

#include <sys/types.h>
#include "hdfi.h"
#include "sis.h"


void unpackEventHeader_s(u_char  *telemetry,
                         u_long  *index,
            struct L1_1SisEvent  *event)

{
   u_long byte;
   u_char PrimaryTelescope;
   u_char range;
   u_char SecondTelescopeHit;

   byte = *index;

   event->flag.stimulated = telemetry[byte+1] >> 7;
   event->flag.maybe = telemetry[byte] >> 7;
   event->flag.hazard = (telemetry[byte+2] >> 4) & 0x01;
   event->flag.PeakTime = (telemetry[byte+2] >> 5) & 0x01;

   event->NumberBytes = telemetry[byte] & 0x07;
   event->BufferId = telemetry[byte+1] & 0x7f;
   PrimaryTelescope = telemetry[byte+2] >> 7;
   SecondTelescopeHit = (telemetry[byte+2] >> 6) & 0x01;
   range = telemetry[byte+2] & 0x0f;
   event->OtherMatrixGroups = (telemetry[byte+3] >> 5) & 0x07;
   event->NumberMatrixStrips = telemetry[byte+3] & 0x1f;
   event->TimeTag = (telemetry[byte+4] >> 5) & 0x0f;
   event->phase = telemetry[byte+4] & 0x1f;

   if (!PrimaryTelescope) {
      event->StackAStatus = 0x01;
      event->StackBStatus = (SecondTelescopeHit) ? 0x02 : 0x00;
      event->RangeA = range;
      event->RangeB = 0x00;
   }
   else {
      event->StackAStatus = (SecondTelescopeHit) ? 0x02 : 0x00;
      event->StackBStatus = 0x01;
      event->RangeA = 0x00;
      event->RangeB = range;
   } 
   
   *index = byte + 5;
}
