/* $Id: unpackMatrixStrips_s.c,v 1.1 1998/01/26 18:11:42 rgr Exp $ */

/* $RCSfile: unpackMatrixStrips_s.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/01/26 18:11:42 $ */
/* $Revision: 1.1 $ */

#include <sys/types.h>
#include "hdfi.h"
#include "sis.h"

#define NSTACK  NUM_SIS_MATRIX_STRIPS


void unpackMatrixStrips_s(u_char  *telemetry,
                          u_long  *index,
             struct L1_1SisEvent  *event)

{
   u_long address;
   u_long byte;
      int i;
   u_long pha;
   u_long plane;
   u_long strip;

   for (i=0; i<NSTACK; i++) {
      event->M1GndPha[i]   = 0xffff;
      event->M1FloatPha[i] = 0xffff;
      event->M2GndPha[i]   = 0xffff;
      event->M2FloatPha[i] = 0xffff;
   }


   byte = *index;
   for (i=0; i < event->NumberMatrixStrips;) {
      strip = (((u_long) telemetry[byte]) << 12)   |
              (((u_long) telemetry[byte+1]) << 4)  |
              (((u_long) telemetry[byte+2]) >> 4);
      plane = strip >> 18;
      address = (strip >> 12) & 0x000003f;
      pha = strip & 0x00000fff;
      if (plane == 0L) event->M1GndPha[address]   = (short) pha;
      if (plane == 1L) event->M1FloatPha[address] = (short) pha;
      if (plane == 2L) event->M2GndPha[address]   = (short) pha;
      if (plane == 3L) event->M2FloatPha[address] = (short) pha;
      i++;
      byte += 3;
      if (i >= event->NumberMatrixStrips) break;
      strip = (((u_long) (telemetry[byte-1] & 0x0f)) << 16) |
              (((u_long) telemetry[byte]) << 8)             |
              ((u_long) telemetry[byte+1]);
      plane = strip >> 18;
      address = (strip >> 12) & 0x000003f;
      pha = strip & 0x00000fff;
      if (plane == 0L) event->M1GndPha[address]   = (short) pha;
      if (plane == 1L) event->M1FloatPha[address] = (short) pha;
      if (plane == 2L) event->M2GndPha[address]   = (short) pha;
      if (plane == 3L) event->M2FloatPha[address] = (short) pha;
      i++;
      byte += 2;
   }
   *index = byte;
}

#undef NSTRIP
