/* $Id: unpackPeakAndOffsetData_s.c,v 1.1 1998/01/26 18:11:43 rgr Exp $ */

/* $RCSfile: unpackPeakAndOffsetData_s.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/01/26 18:11:43 $ */
/* $Revision: 1.1 $ */

#include <sys/types.h>
#include "hdfi.h"
#include "sis.h"


void unpackPeakAndOffsetData_s(u_char  *telemetry,
                               u_long  *index,
                  struct L1_1SisEvent  *event)

{
   u_long byte;
   u_long offsets;

   if (event->flag.PeakTime) {
      byte = *index;
      event->PeakTimeT1 = telemetry[byte] >> 4;
      event->PeakTimeM2 = telemetry[byte] & 0x0f;
      event->PeakTimeM1 = telemetry[byte+1] >> 4;
      offsets = (((u_long) telemetry[byte+1]) << 16) |
                (((u_long) telemetry[byte+2]) << 8)  |
                 ((u_long) telemetry[byte+3]);
      event->M1GndSideOffset = (u_char) ((offsets >> 15) & 0x0000001f);
      event->M1HvSideOffset  = (u_char) ((offsets >> 10) & 0x0000001f);
      event->M2GndSideOffset = (u_char) ((offsets >>  5) & 0x0000001f);
      event->M2HvSideOffset  = (u_char) (offsets         & 0x0000001f);
      *index = byte + 4;
   }
   else {
      event->PeakTimeT1      = 0xff;
      event->PeakTimeM2      = 0xff;
      event->PeakTimeM1      = 0xff;
      event->M1GndSideOffset = 0xff;
      event->M1HvSideOffset  = 0xff;
      event->M2GndSideOffset = 0xff;
      event->M2HvSideOffset  = 0xff;
   }
}
