/* $Id: unpackStimData_s.c,v 1.1 1998/01/26 18:11:44 rgr Exp $ */

/* $RCSfile: unpackStimData_s.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/01/26 18:11:44 $ */
/* $Revision: 1.1 $ */

#include <sys/types.h>
#include "hdfi.h"
#include "sis.h"


void unpackStimData_s(u_char  *telemetry,
                      u_long  *index,
         struct L1_1SisEvent  *event)

{
   u_long byte;

   if (event->flag.stimulated) {
      byte = *index;
      event->stimulated.stmask = (((u_short) telemetry[byte]) << 8) |
                                  ((u_short) telemetry[byte+1]);
      event->stimulated.vref1 = telemetry[byte+2];
      event->stimulated.vref2 = telemetry[byte+3];
      event->stimulated.MatrixGndSide = telemetry[byte+4];
      event->stimulated.AMatrixHvSide = telemetry[byte+5];
      event->stimulated.BMatrixHvSide = telemetry[byte+6];
      event->stimulated.gain_f2 = (telemetry[byte+7] >> 5) & 0x01;
      event->stimulated.gain_f1 = (telemetry[byte+7] >> 4) & 0x01;
      event->stimulated.vref = telemetry[byte+7] & 0x0f;
      event->stimulated.CalSequence =
                                 (((u_short) telemetry[byte+8]) << 8) |
                                  ((u_short) telemetry[byte+9]);
      *index = byte + 10;
   }
   else {
      event->stimulated.stmask        = 0xffff;
      event->stimulated.vref1         = 0xff;
      event->stimulated.vref2         = 0xff;
      event->stimulated.MatrixGndSide = 0xff;
      event->stimulated.AMatrixHvSide = 0xff;
      event->stimulated.BMatrixHvSide = 0xff;
      event->stimulated.gain_f2       = 0xff;
      event->stimulated.gain_f1       = 0xff;
      event->stimulated.vref          = 0xff;
      event->stimulated.CalSequence   = 0xffff;
   }
}
