/* $Id: BrowseSisPigeonHole.c,v 1.1 1998/01/26 18:16:10 rgr Exp $ */

/* $RCSfile: BrowseSisPigeonHole.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/01/26 18:16:10 $ */
/* $Revision: 1.1 $ */


#include <stdio.h>
#include <string.h>

#include "mfhdf.h"
#include "df.h"

#include "aosr.h"
#include "ccr.h"

#include "cris.h"
#include "sis.h"

#include "asc/prototype.h"
#include "sisPutData.h"


void main(argc, argv)
int argc;
char *argv[];
{
  int32 hdf_fp, sd_id;
  struct BrowseSis  browses;
  int ii,retval;

  if (argc!=2)
    {
      printf("Usage: rd_hdf hdf_file\n");
      exit(1);
    }

  /* open hdf input file */

  if ((hdf_fp=Hopen(argv[1], DFACC_ALL, 0))==FAIL)
    {
      fprintf(stderr, "Hopen: could not open hdf file\n");
      exit(-1);
    }
  Vstart(hdf_fp);

if ((sd_id=SDstart(argv[1], DFACC_WRITE))==FAIL)
    {
      fprintf(stderr, "SDstart: could not open hdf file\n");
      exit(-1);
    }
  printf("\n");

 
  ii = 0;
  if (init_rd_BrowseSis(hdf_fp, sd_id)) {
     while((retval= read_BrowseSis(&browses,ii))!=FAIL) {
        putSisBrowseParameters(&browses);
        ii++;
     }
  }
  printf(" Number of SIS Browse structures written: %d\n", ii);

  /* all done, close HDF file */

  close_rd_BrowseSis();

  Vend(hdf_fp);
  if (SDend(sd_id)==FAIL)
    {
      fprintf(stderr, "SDend: could not close hdf file\n");
      exit(-1);
    }
  if (Hclose(hdf_fp)==FAIL)
    {
      fprintf(stderr, "Hclose: could not close hdf file\n");
      exit(-1);
    }

  exit(0);
}
